Program	Dit;
uses
	crt;
type
	str80=string[80];
	PBran=^Bran;
	Bran=record
		ch:byte;
		br:array[0..1]of PBran;
	end;
	code=array[0..37]of byte;
var
	count:array[0..255]of longint;
	codes:array[0..255]of code;
	start:code;
	root:Bran;
	c:char;
	all,out,w:longint;
	file1,file2:str80;
	idx,j:byte;
	blb:string;

Procedure Countchars(name:str80);
	var
		inf:file;
		i,get:word;
		blk:array[1..2048] of byte;
	begin
		for i := 0 to 255 do count[i]:=0;
		assign(inf,name);
		reset(inf,1);
		repeat
			blockread(inf,blk,sizeof(blk),get);
			for i := 1 to get do inc(count[blk[i]]);
		until get=0;
		close(inf);
	end;

Procedure B_tree;
	var
		dummy:bran;
		min1,min2,i,chars:byte;
		tree:array[0..255]of Pbran;
	Procedure findmin(var m1,m2:byte);
		var
			i:byte;
			c1,c2:longint;
		begin
			c1:=$7FFFFFFF;
			c2:=c1;
			for i := 0 to 255 do
				if tree[i]<>nil then
				begin
					if c1>=Count[i] then
					begin
						c2:=c1;
						c1:=count[i];
						m2:=m1;
						m1:=i;
					end
					else
					if c2>=count[i] then
					begin
						c2:=count[i];
						m2:=i;
					end;
				end;
		end;
	begin
		chars:=255;
		for i := 0 to 255 do
			if count[i]=0 then
			begin
				tree[i]:=nil;
				dec(chars);
			end
			else
			begin
				new(tree[i]);
				tree[i]^.ch:=i;
				tree[i]^.br[0]:=nil;
				tree[i]^.br[1]:=nil;
			end;
		for i := 1 to chars do
		begin
			findmin(min1,min2);
			dummy.ch:=min1;
			dummy.br[0]:=tree[min1];
			dummy.br[1]:=tree[min2];
			new(tree[min1]);
			tree[min1]^:=dummy;
			count[min1]:=count[min1]+count[min2];
			tree[min2]:=nil;
		end;
		i:=0;
		while tree[i]=nil do inc(i);
		root:=tree[i]^;
		all:=count[i];
	end;

Procedure Defcode(branch:bran;startval:code);
	begin
		if (branch.br[0]=nil)and(branch.br[1]=nil) then
			codes[branch.ch]:=startval
		else
		begin
			startval[startval[0] div 8+1]:=startval[startval[0] div 8+1] and ($FF-1 shl(Startval[0]mod 8));
			inc(startval[0]);
			defcode(branch.br[0]^,startval);
			dispose(branch.br[0]);
			dec(startval[0]);
			startval[startval[0] div 8+1]:=startval[startval[0] div 8+1] or (1 shl(Startval[0]mod 8));
			inc(startval[0]);
			defcode(branch.br[1]^,startval);
			dispose(branch.br[1]);
		end;
	end;

Procedure kompress(name1,name2:str80);
	var
		i,value,bit,ou:byte;
		m:integer;
		inf,ouf:file of byte;
		pro:longint;
	begin
		bit:=0;pro:=0;w:=0;
		assign(inf,name1);
		assign(ouf,name2);
		reset(inf);
		rewrite(ouf);
		ou:=158;
		write(ouf,ou);
		for i := 0 to 3 do
		begin
			ou:=(all shr(24-8*i))and $FF;
			write(ouf,ou);
		end;
		for i := 0 to 255 do
		begin
			for m := 0 to codes[i,0]-1 do
			begin
				ou:=ou shl 2 +(codes[i,m div 8+1] shr (m mod 8)) and $01;
				inc(bit);
				inc(bit);
				if bit=8 then
				begin
					write(ouf,ou);
					bit:=0;
				end;
			end;
			ou:=ou shl 2+3;
			inc(bit);
			inc(bit);
			if bit=8 then
			begin
				write(ouf,ou);
				bit:=0;
			end;
		end;
		while not(eof(inf)) do
		begin
			inc(pro);
			read(inf,value);
			for i := 0 to codes[value,0]-1 do
			begin
				ou:=(ou shl 1)+(codes[value,i div 8+1]shr(i mod 8))and$01;
				inc(bit);
				inc(w);
				if w=1000 then
				begin
					w:=0;
					write(#13);clreol;write('Progress : ',100*pro/all:3:0,'%');
				end;
				if bit=8 then
				begin
					write(ouf,ou);
					bit:=0;
				end;
			end;
		end;
		if bit > 0 then
		begin
			for i := bit to 7 do ou:=ou shl 1+1;
			write(ouf,ou);
		end;
		out:=filesize(ouf);
		close(inf);
		close(ouf);
	end;

Procedure dekompress(name1,name2:str80);
	var
		i,np,value,bit,ou:byte;
		inf,ouf:file of byte;
		dummy,dummyx:Pbran;
	begin
		assign(inf,name1);
		assign(ouf,name2);
		reset(inf);
		rewrite(ouf);
		read(inf,value);
		case value of
		158:begin
			bit:=8;w:=0;
			root.br[0]:=nil;
			root.br[1]:=nil;
			dummy:=@root;
			read(inf,value);
			all:=value;
			read(inf,value);
			all:=all shl 8+value;
			read(inf,value);
			all:=all shl 8+value;
			read(inf,value);
			all:=all shl 8+value;
			read(inf,value);
			for i := 0 to 255 do
			begin
				while ((Value shr (bit-1))and 1)=0 do
				begin
					np:=(value shr(bit-2))and 1;
					if dummy^.br[np]=nil then
					begin
						new(dummyx);
						dummy^.br[np]:=dummyx;
						dummyx^.br[0]:=nil;
						dummyx^.br[1]:=nil;
					end;
					dummy:=dummy^.br[np];
					dec(bit);
					dec(bit);
					if bit = 0 then
					begin
						if eof(inf) then begin
							writeln;
							writeln;
							writeln('ERROR #9 : File isn"t complete.');
							halt(1);
						end;
						read(inf,value);
						bit:=8;
					end;
				end;
				dummy^.ch:=i;
				dummy:=@root;
				dec(bit);
				dec(bit);
				if bit = 0 then
				begin
					if eof(inf) then begin
						writeln;
						writeln;
						writeln('ERROR #9 : File isn',#39,'t complete.');
						halt(1);
					end;
					read(inf,value);
					bit:=8;
				end;
			end;
			out:=0;
			while out < all do
			begin
				if bit=0 then
				begin
					if eof(inf) then begin
						writeln;
						writeln;
						writeln('ERROR #9 : File isn',#39,'t complete.');
						halt(1);
					end;
					read(inf,value);
					bit:=8;
				end;
				dummy:=dummy^.br[(value shr(bit-1)) and $01];
				if (dummy^.br[0]=nil)and(dummy^.br[1]=nil) then
				begin
					inc(w);
					if w=1000 then
					begin
						w:=0;
						write(#13);clreol;write('Progress : ',100*out/all:3:0,'%');
					end;
					write(ouf,dummy^.ch);
					dummy:=@root;
					inc(out);
				end;
				dec(bit);
			end;
		end;
		else begin
			writeln;
			writeln;
			writeln('ERROR #14 : This version can',#39,'t support this metod of');
			writeln('packing or this file no packed in this program.');
		end;
		end;
		close(inf);
		close(ouf);
	end;

begin
	writeln('DitPack v1.0');
	writeln('Copyright (C) Disoft 1991-2005');
	writeln;
	clrscr;
	writeln;
	writeln('DitPack v1.0');
	writeln('Copyright (C) Disoft 1991-2005');
	writeln;
	write('In file : ');readln(file1);
	write('Out file : ');readln(file2);
	write('(C)ommpress/E(x)tract/(Q)uit');
	repeat
		c:=upcase(readkey);
	until c in ['X','C','Q'];
	case c of
	'C':begin
		write(#13);clreol;
		writeln('(C)ommpress');
		countchars(file1);
		B_Tree;
		writeln;
		for idx := 0 to 32 do
			start[idx]:=0;
		for idx := 0 to 255 do
			codes[idx]:=start;
		defcode(root,start);
		writeln('Compressing');
		kompress(file1,file2);
		write(#13);clreol;
		write('Compress ratio :',100*out/all:5:2);
	end;
	'X':begin
		write(#13);clreol;
		writeln('            E(x)tract');
		writeln;
		writeln('Extracting');
		dekompress(file1,file2);
		write(#13);clreol;
		write('Status : OK');
	end;end;
	readln;
end.